// plugin.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include <windows.h>
#include <ddraw.h>
#include <stdio.h>

#include "Filters/scaler.h"
#include "plugin.h"


//CreateSurface
typedef DWORD (__stdcall *PFN01_06)(DWORD a0, LPDDSURFACEDESC a1, LPDIRECTDRAWSURFACE* a2, DWORD a3);
//BltFast
typedef DWORD (__stdcall *PFN04_07)(LPDIRECTDRAWSURFACE a0, DWORD a1, DWORD a2, LPDIRECTDRAWSURFACE a3, LPRECT a4, DWORD a5);
//GetSurfaceDesc
typedef DWORD (__stdcall *PFN04_022)(LPDIRECTDRAWSURFACE a0, LPDDSURFACEDESC a1);
//Lock
typedef DWORD (__stdcall *PFN04_025)(LPDIRECTDRAWSURFACE a0, DWORD a1, LPDDSURFACEDESC a2, DWORD a3, DWORD a4);
//Unlock
typedef DWORD (__stdcall *PFN04_032)(LPDIRECTDRAWSURFACE a0, DWORD a1);

char szPluginName[] = "MDKD3D";

//Global
DWORD				ScaleFilter=0;

PFN_OUT2LOG			out2log=0;
PFN_GET_METHOD_ADDR	get_method_addr=0;

LPDIRECTDRAWSURFACE	lpPrim=0;	//PrimarySurface
LPDIRECTDRAWSURFACE	lpBB=0;		//BackBuffer
LPDIRECTDRAWSURFACE	lpMySurf=0;	//TempSurface In SystemMemory

BYTE		*ssBuf=0;

PFN04_07	BltFast=0;
PFN04_025	Lock=0;
PFN04_032	Unlock=0;

//DWORD before(DWORD retaddr, DWORD *params, PVOID pF){
//DWORD after (DWORD retaddr, DWORD *params, DWORD *presult)

void init_user_plugin(){
//Add You Initialization Code Here
	Init_2xSaI(565);
	InitLUTs();

	ssBuf = (BYTE*)malloc(2*640*484);
	ZeroMemory(ssBuf, 2*640*480);
	ssBuf+=640*2*2;
}

DWORD bef_IDirectDraw2_SetDisplayMode(DWORD retaddr, DWORD *params, PVOID pF){
	params[1]=1366;
	params[2]=768;
	return 0;
}

DWORD bef_IDirectDraw_CreateSurface(DWORD retaddr, DWORD *params, PVOID pF){
	static DWORD f_surf=0;
	if(!f_surf){
		//Create surface in system memory for image processing
		f_surf++;
		CreateSurface(params[0]);
	}
	return 0;
}

//   STDMETHOD(GetAttachedSurface)(THIS_ LPDDSCAPS, LPDIRECTDRAWSURFACE FAR *) PURE;
DWORD after_IDirectDrawSurface_GetAttachedSurface(DWORD retaddr, DWORD *params, DWORD *presult){
	DWORD * lpAtSurf = (DWORD*)params[2];

	if(*lpAtSurf){
		lpBB = (LPDIRECTDRAWSURFACE)*lpAtSurf;
		wrlog("Primary    surface: %08X\n", params[0]);
		wrlog("BackBuffer surface: %08X\n", *lpAtSurf);
	}
	return 0;
}


DWORD bef_IDirectDrawSurface_Flip(DWORD retaddr, DWORD *params, PVOID pF){
//	FRAME READY
	DDSURFACEDESC sd;
	RECT rc;
	DWORD res;

	if(BltFast==0)	{BltFast =	(PFN04_07) get_method_addr("IDirectDrawSurface_BltFast");}
	if(Lock==0)		{Lock =		(PFN04_025)get_method_addr("IDirectDrawSurface_Lock");}
	if(Unlock==0)	{Unlock=	(PFN04_032)get_method_addr("IDirectDrawSurface_Unlock");}

	//copy surface data from video memory to system memory
	rc.left   = 0;
	rc.top    = 0;
	rc.right  = 640;
	rc.bottom = 480;
	res = BltFast(lpMySurf, 0, 0, (LPDIRECTDRAWSURFACE)lpBB, &rc, DDBLTFAST_WAIT);
	wrlog("BltFast res=%08X\n", res);


	ZeroMemory(&sd, sizeof(sd));
	sd.dwSize=sizeof(sd);
	res = Lock(lpMySurf,  0, &sd, 0, 0);

	//Process Frame
	//!!!FOR TEST!!! 100x100 square draw
//	for(DWORD i=0; i<30; i++){memset((BYTE*)sd.lpSurface+2*1366*i, 0xcc, 2*30);}

	filt((WORD*)sd.lpSurface);

	res = Unlock(lpMySurf, (DWORD)sd.lpSurface);
	
	//////////////////////////////////////////////////////////////////////////
	//Copy surface data from system memory to video memory
	rc.left   = 0;
	rc.top    = 0;
	rc.right  = 1366;
	rc.bottom = 768;
	res = BltFast((LPDIRECTDRAWSURFACE)lpBB, 0, 0, lpMySurf, &rc, DDBLTFAST_WAIT);

	return 0;
}

PLUGIN_DAT plugins[]=
{	
	{	
		"IDirectDraw2_SetDisplayMode",
		bef_IDirectDraw2_SetDisplayMode,
		0
	},						
	{
		"IDirectDraw_CreateSurface",
		bef_IDirectDraw_CreateSurface,
		0
	},
	{
		"IDirectDrawSurface_GetAttachedSurface",
		0,
		after_IDirectDrawSurface_GetAttachedSurface
	},
	{
		"IDirectDrawSurface_Flip",
		bef_IDirectDrawSurface_Flip,
		0
	}
};

BOOL APIENTRY DllMain( HANDLE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved){
	return TRUE;
}
void wrlog(PCHAR fmt, ...){
	char buf[0x400];

	va_list ap;
	va_start(ap, fmt);
	vsprintf(buf, fmt, ap);
	out2log(buf);
	va_end(ap);
}
//------------------------
//Exported Functions
//------------------------
extern "C" char * start_plugin(HINSTANCE hIntruder, DWORD dwVer){
	if(dwVer!=PLUGVER) return 0;//Versions mismatch. Can't init

	out2log=(PFN_OUT2LOG)GetProcAddress(hIntruder, "out2log");
	get_method_addr = (PFN_GET_METHOD_ADDR)GetProcAddress(hIntruder, "get_method_addr");

	init_user_plugin();

	return szPluginName;
}

extern "C" char * register_handler(PLUGIN_REG *plug){
	static DWORD id=0;

	if(id<(sizeof(plugins)/sizeof(PLUGIN_DAT))){
		id++;
		plug->before = plugins[id-1].before;
		plug->after	 = plugins[id-1].after;
		return	plugins[id-1].szName;
	}
	return 0;
}

void CreateSurface(DWORD pDD){
	wrlog("...::: CreateSurface :::...\n");
	PFN01_06 e= (PFN01_06)get_method_addr("IDirectDraw_CreateSurface");
	//wrlog("get_method_addr=%08X\n", e);

	DDSURFACEDESC descr;
	ZeroMemory(&descr, sizeof(descr));
	descr.dwSize=sizeof(descr);
    descr.dwFlags = DDSD_WIDTH | DDSD_HEIGHT | DDSD_CAPS;
	descr.dwWidth=1366;
	descr.dwHeight=768;
	descr.ddsCaps.dwCaps=DDSCAPS_OFFSCREENPLAIN | DDSCAPS_SYSTEMMEMORY;
	
	DWORD res=e(pDD, &descr, &lpMySurf, 0);
	wrlog("RES=%08X. lpMySurf=%08X\n", res, lpMySurf);
}


void filt(void* psrc){
//Copy From psrc to buffer
	for(DWORD i=0; i<480;i++){memcpy((BYTE*)ssBuf+2*640*i, (BYTE*)psrc+2*1366*i, 2*640);}

	//clear buffer
	memset(psrc, 0, 2*1366*768);

	if(GetAsyncKeyState(VK_F4)){
		Sleep(500);
		ScaleFilter++;
		if(ScaleFilter > 2) ScaleFilter=0;
	}

	switch (ScaleFilter) {
		case 0:
			zoom2x((unsigned char *)ssBuf, 2*640, (unsigned char *)psrc, 2*1366, 640, 480);
			break;
		case 1:
			sinclair((unsigned char *)ssBuf, 2*640, (unsigned char *)psrc, 2*1366, 640, 480);
			break;
		case 2:
			sinclair_chunk((unsigned char *)ssBuf, 2*640, (unsigned char *)psrc, 2*1366, 640, 480);
			break;

		default:
			AdvMame2x((unsigned char *)ssBuf, 2*640, (unsigned char *)psrc, 2*1366, 640, 480);
			break;
	}

	for(DWORD i=0; i<120; i++)		{memset((BYTE*)ssBuf+2*1366*i, 0x0, 2*1366);}
	for(DWORD i=840; i<768; i++)	{memset((BYTE*)psrc+2*1366*i, 0x0, 2*1366);}

	for(DWORD i=0; i<768; i++)		{
		memset((BYTE*)psrc+2*1366*i, 0x0, 2*120);
		memset((BYTE*)psrc+2*(1366-120)+2*1366*i, 0x0, 2*120);
	}
}

void zoom2x(uint8 *psrc, uint32 srcPitch, uint8 *pdst, uint32 dstPitch, int width, int height){
	
	WORD *pS=0, *pD=0;
	//Copy from src to dst
	for(DWORD i=0; i<480; i++){
		pS=(WORD*)psrc+640*i;
		pD=(WORD*)pdst +2*1366*i;
		for(DWORD j=0; j<640; j++){
			*pD=*pS;
			*(pD+1366)=*pS;
			pD++;
			*pD=*pS;
			*(pD+1366)=*pS;
			pS++;
			pD++;
		}
	}
}

//spectrum color table
RGB ct[14]={
	{0,0,0},	//0 - chernii
	
	{190,0,0},	//1 - temno krasii
	{255,0,0},	//2 - krasnii
	
	{190,190,0},//3 - temno geltii
	{255,255,0},//4 - geltii
	
	{0,255,0},	//6 - zelenii	
	{0,190,0},	//5 - temno zel
	
	{0,255,255},//8 - golub
	{0,190,190},//7 - temno golub
	
	{0,0,255},	//10- sinii
	{0,0,190},	//9 - temno sinii

	{255,0,255},//11- fiolet
	{170,170,170},//12-serii
	
	{255,255,255}//13-belii
};

#define R0	1*18
#define R1	2*18
#define R2	3*18
#define R3	4*18
#define R4	5*18
#define R5	6*18
#define R6	7*18
#define R7	8*18
#define R8	9*18
#define R9	10*18
#define R10	11*18
#define R11 12*18
#define R12 13*18

RANGE range[14]={
	{0, R0},	//0
	{R0, R1},	//1
	{R1, R2},	//2
	{R2, R3},	//3
	{R3, R4},	//4
	{R4, R5},	//5
	{R5, R6},	//6
	{R6, R7},	//7
	{R7, R8},	//8
	{R8, R9},	//9
	{R9, R10},	//10
	{R10,R11},	//11
	{R11,R12},	//12
	{R12,255}	//13
};

void sinclair(uint8 *psrc, uint32 srcPitch, uint8 *pdst, uint32 dstPitch, int width, int height){
	WORD *pS = 0, *pD = 0;
	pS = (WORD*)psrc;
	pD = (WORD*)pdst;
	//Copy from src to dst
	for(DWORD i = 0; i < 240 - 1; i++){
		for(DWORD j = 0; j < 320 - 1; j++){

			WORD cc = pS[640 * (2 * i) + (2 * j)];

			WORD r = (cc & 0xF800) >> 8;
			WORD g = (cc & 0x07E0) >> 3;
			WORD b = (cc & 0x001F) << 3;
			WORD gr = r * 0.3f + g * 0.59f + b * 0.11f;

			int zz = 0;
			//Find Range Of Color
			for(zz = 0; zz < 14; zz++){
				if(gr>=range[zz].left && gr<=range[zz].right) break;
			}

			WORD rr = 0, gg = 0, bb = 0;
			rr = ct[zz].r >> 3;
			gg = ct[zz].g >> 3;
			bb = ct[zz].b >> 3;

			WORD c = 0;
			c |= bb;
			c |= gg << 6;
			c |= rr << 11;
			
			DWORD foo = 1366 * 4 * i + 4 * j;




			pD[foo + 0 + 0 * 1366] = c;
			pD[foo + 1 + 0 * 1366] = c;
			pD[foo + 2 + 0 * 1366] = c;
			pD[foo + 3 + 0 * 1366] = c;

			pD[foo + 0 + 1 * 1366] = c;
			pD[foo + 1 + 1 * 1366] = c;
			pD[foo + 2 + 1 * 1366] = c;
			pD[foo + 3 + 1 * 1366] = c;

			pD[foo + 0 + 2 * 1366] = c;
			pD[foo + 1 + 2 * 1366] = c;
			pD[foo + 2 + 2 * 1366] = c;
			pD[foo + 3 + 2 * 1366] = c;

			pD[foo + 0 + 3 * 1366] = c;
			pD[foo + 1 + 3 * 1366] = c;
			pD[foo + 2 + 3 * 1366] = c;
			pD[foo + 3 + 3 * 1366] = c;

		}
	}

}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
// CHUNK PART
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
CHUNK ch[13]={
//-----------------------------
// ->0
// ****
// ****
// ****
// ****
	{
		0,0,0,0,
		0,0,0,0,
		0,0,0,0,
		0,0,0,0
	},
//-----------------------------
// ->1
// ***
// ****
// * **
// ****
	{
		0,0,0,-1,
		0,0,0,0,
		0,-1,0,0,
		0,0,0,0
	},
//-----------------------------
// ->2
// ***
// ****
// * *
// ****
	{
		0,0,0,-1,
		0,0,0,0,
		0,-1,0,-1,
		0,0,0,0
	},
//-----------------------------
// ->3
// * *
// ****
// * *
// ****
	{
		0,-1,0,-1,
		0,0,0,0,
		0,-1,0,-1,
		0,0,0,0
	},
//------------------------------
// ->4
// * *
// ** *
// * *
// ****
	{
		0,-1,0,-1,
		0,0,-1,0,
		0,-1,0,-1,
		0,0,0,0
	},
//-----------------------------
// ->5
// * *
// ** *
// * *
//  ***	
	{
		0,-1,0,-1,
		0,0,-1,0,
		0,-1,0,-1,
		-1,0,0,0
	},
//-----------------------------
// ->6
// * *
//  * *
// * *
//  * *
	{
		0,-1,0,-1,
		-1,0,-1,0,
		0,-1,0,-1,
		-1,0,-1,0
	},
//-----------------------------
// ->7
// * *
//  *
// * *
//    *
	{
		0,-1,0,-1,
		-1,0,-1,-1,
		0,-1,0,-1,
		-1,-1,-1,0
	},
//-----------------------------
// ->8
//  * *
//   *
//  * *
//
	{
		-1,0,-1,0,
		-1,-1,0,-1,
		-1,0,-1,0,
		-1,-1,-1,-1
	},
//-----------------------------
// ->9
//   * *
//
//   * *
//
	{
		-1,0,-1,0,
		-1,-1,-1,-1,
		-1,0,-1,0,
		-1,-1,-1,-1
	},
//-----------------------------
// ->10
//  *
//
//  * *
//
	{
		-1,0,-1,-1,
		-1,-1,-1,-1,
		-1,0,-1,0,
		-1,-1,-1,-1
	},
//-----------------------------
// ->11
// | *
// |
// |   *
//
	{
		-1,0,-1,-1,
		-1,-1,-1,-1,
		-1,-1,-1,0,
		-1,-1,-1,-1
	},
//-----------------------------
// ->12
//
//
//
	{
		-1,-1,-1,-1,
		-1,-1,-1,-1,
		-1,-1,-1,-1,
		-1,-1,-1,-1
	}
};

#define R1_0	1*20
#define R1_1	2*20
#define R1_2	3*20
#define R1_3	4*20
#define R1_4	5*20
#define R1_5	6*20
#define R1_6	7*20
#define R1_7	8*20
#define R1_8	9*20
#define R1_9	10*20
#define R1_10	11*20
#define R1_11	12*20

RANGE range2[13]={
	{0, R1_0},		//0
	{R1_0, R1_1},	//1
	{R1_1, R1_2},	//2
	{R1_2, R1_3},	//3
	{R1_3, R1_4},	//4
	{R1_4, R1_5},	//5
	{R1_5, R1_6},	//6
	{R1_6, R1_7},	//7
	{R1_7, R1_8},	//8
	{R1_8, R1_9},	//9
	{R1_9, R1_10},	//10
	{R1_10,R1_11},	//11
	{R1_11,255}		//12
};
void sinclair_chunk(uint8 *psrc, uint32 srcPitch, uint8 *pdst, uint32 dstPitch, int width, int height){
	WORD *pS=0, *pD=0;
	pS=(WORD*)psrc;
	pD=(WORD*)pdst;
	//Copy from src to dst
	for(DWORD i=0; i<240-1; i++){
		for(DWORD j=0; j<320-1; j++){

			WORD cc=pS[640*(2*i)+(2*j)];

			WORD r=(cc&0xF800)>>8;
			WORD g=(cc&0x7E0)>>3;
			WORD b=(cc&0x1F)<<3;
			WORD gr=r*0.3f+g*0.59f+b*0.11f;

			int zz=0;
			for(zz=0;zz<13;zz++){
				if(gr>=range2[zz].left && gr<=range2[zz].right) break;
			}

			DWORD foo=1366*4*i+4*j;

			pD[foo+0+0*1366]=ch[zz].dd[0];
			pD[foo+1+0*1366]=ch[zz].dd[1];
			pD[foo+2+0*1366]=ch[zz].dd[2];
			pD[foo+3+0*1366]=ch[zz].dd[3];

			pD[foo+0+1*1366]=ch[zz].dd[4];
			pD[foo+1+1*1366]=ch[zz].dd[5];
			pD[foo+2+1*1366]=ch[zz].dd[6];
			pD[foo+3+1*1366]=ch[zz].dd[7];

			pD[foo+0+2*1366]=ch[zz].dd[8];
			pD[foo+1+2*1366]=ch[zz].dd[9];
			pD[foo+2+2*1366]=ch[zz].dd[10];
			pD[foo+3+2*1366]=ch[zz].dd[11];

			pD[foo+0+3*1366]=ch[zz].dd[12];
			pD[foo+1+3*1366]=ch[zz].dd[13];
			pD[foo+2+3*1366]=ch[zz].dd[14];
			pD[foo+3+3*1366]=ch[zz].dd[15];

		}
	}
}
